<?php
# Erstewllt von Alfred Mller
# Da ich die Datendateien fr eine Javaanwendung schon hatte, habe ich sie einfach auch fr dieses PHP-Script als Eingabe genutzt.
# Die Java-Anwendung luft aber nicht mehr in den aktuellen Browsern und dafr habe ich jetzt diese Script gestrickt.


# bergabe Daten lesen: Die Datei mit den Daten ohne die Endung .txt
$daten     = $_GET[daten];

# Hier den Pfad zu der Datendatei angeben
$datei     = 'https://www.xyz.de/';
$datei    .= $daten;
$datei    .= '.txt';

# Hier wird die Datendatei eingelesen. Je Zeile wird ein Satz abgestellt, mit Satzendezeichen.
$dat       = file ( $datei );
$y         = 0;
$l         = count ( $dat );

# Die Daten auseinandernehmen
for ( $x = 0; $x < $l; $x++ ) {

# In allen Zeilen werden die Werte durch ';' abgegrenzt.
  $inh  =  split ( ';', $dat[$x] );

# Die Titelzeile, die im Start ausgegeben wird.
  if ( $inh[0] == 'title ' ) {
    $lang   = strlen ( $inh[1] );
    $lang   = $lang - 1;
    $inh[1] = substr($inh[1],0,$lang);
    $titel = $inh[1];
  }

# In den Col-Zeilen stehen die Texte zu jedem Graph und die gewnschte Farbe als Dezimalwert!
  elseif ( $inh[0] == 'col ' ) {
    $lang   = strlen ( $inh[2] );
    $lang   = $lang - 1;
    $inh[2] = substr($inh[2],0,$lang);
    $text[$y]  = $inh[1];
    $farbe[$y] = $inh[2] + 0;
    $y++;
  }

# In der letzten Zeile kann als erstes noch ein Text stehen, der im Titel in Klammern gesetzt wird
# und danach kommen die einzelnen Werte, aus denen die Graphen berechnet werden.
  else {
    $art = $inh[0];
    $z   = count($inh);
    for ( $i = 1; $i < $z; $i++ ) {
      $k = $i - 1;
      $wert[$k] = $inh[$i] + 0;
    }
  }
}

if ( ! empty ( $art ) ) {
  $titel  .= ' (';
  $titel  .= $art;
  $titel  .= ')';
}

# Wenn man breitere oder schmalere Ausgabebilder haben will, muss der Wert 500 angepasst werden.
$hoch = max($wert);
$berech = 500 / $hoch;
$m   = count ( $wert );

# Hhe und Breite der Graphen ermitteln
for ( $x = 0; $x < $m; $x++ ) {
  $wert1[$x]  = $wert[$x] * $berech;
}
$breit = ( 500 / $x ) - 4;

# Vorbereitungen abgeschlossen, jetzt geht es ans Zeichnen; eine 600 x 600 px Grafik mit einem leicht grauen Hintergrund.
$chart = imagecreate ( 600, 600 );
$hintergr = imagecolorallocate ( $chart, 243, 243, 243 );
imagefill ( $chart,0,0,$hintergr);

# Schriftfarbe auf Schwarz setzen und den Titel ausgeben.
$schwarz  = imagecolorallocate ( $chart, 0, 0, 0 );

# Wenn man ein Font im Webverzeichnis hat, kann er hier einfach angegeben werden (hier Arial Bold), ansonsten sollte man besser den kompletten Pfad angeben.
# Wenn kein Font vorhanden ist, mit dem Standard arbeitn und die Zeile imagestring aktivieren und imagettftext auskommentieren.
#imagestring ( $chart, 5, 10, 10, $titel, $schwarz);
imagettftext ( $chart, 14, 0, 10, 40, $schwarz, '/arialbd.ttf', $titel);

# Schwarze Abschlusslinie
# Auch hier bei anders dimensionierten Ausgaben die Werte anpassen
imageline ( $chart, 0, 590, 500, 590, $schwarz );

# Jetzt die Graphen ziehen
for ( $x = 0; $x < $m; $x++ ) {
  $rot        = 0;
  $gruen      = 0;
  $blau       = 0;

# Den bergebenen dezimalen Farbwert in einen Hex-Wert umsetzen.
# Hierbei knnen natrlich auch weniger als die erforderlichen 6 Stellen herauskommen!
  $hexa       = dechex ( $farbe[$x] ) ;
  $lang       = strlen ( $hexa );
  if ( $lang  == 1 ) {
    $hexz     = '00000';
    $hexz    .= $hexa;
    $hexa     = $hexz;
  }
  if ( $lang  == 2 ) {
    $hexz     = '0000';
    $hexz    .= $hexa;
    $hexa     = $hexz;
  }
  if ( $lang  == 3 ) {
    $hexz     = '000';
    $hexz    .= $hexa;
    $hexa     = $hexz;
  }
  if ( $lang  == 4 ) {
    $hexz     = '00';
    $hexz    .= $hexa;
    $hexa     = $hexz;
  }
  if ( $lang  == 5 ) {
    $hexz     = '0';
    $hexz    .= $hexa;
    $hexa     = $hexz;
  }

# Jetzt den ermittelten 6-stelligen Hex-Wert in die RGB-Farbwerte umsetzen.
# Wer will, kann natrlich schon bei der Eingabe der 'col' Zeilen den RGB-Farbwert als 3 mit ';' getrennte Werte bernehmen. Dann kann man sich ein paar Zeilen Code sparen.
  $hex1       = substr($hexa,0,2);
  $hex2       = substr($hexa,2,2);
  $hex3       = substr($hexa,4,2);
  $rot        = hexdec ( $hex1 );
  $gruen      = hexdec ( $hex2 );
  $blau       = hexdec ( $hex3 );
  $cfarbe = imagecolorallocate ( $chart, $rot, $gruen, $blau );
  $start = ( ( $breit + 4 ) * $x ) + 4;
  $endeu = $start + $breit;

# Die 589 bei anders dimensionierten Ausgaben anpassen!
  $endeo = 589 - $wert1[$x];
  imagefilledrectangle ( $chart, $start, 589, $endeu, $endeo, $cfarbe );
  $start = $start + 10;
  $text1  = $text[$x];
  $text1 .= ' / ';
  $text1 .= $wert[$x];

# Hier ebenso verfahren, wie bei der Titelausgabe!
# Die 585 bei anders dimensionierten Ausgaben anpassen!
#  imagestringup ( $chart, 2, $start, 585, $text1, $schwarz );
  imagettftext ( $chart, 8, 90, $start, 585, $schwarz, '/arial.ttf', $text1);
}

# Ausgabe der Grafik
# Hier nach Wunsch den Bild-Namen anpassen. Hier wird 'Ausgabe+Name der Datendatei+.jpg' genommen.
$dateiaus  = "Ausgabe";
$dateiaus .= $daten;
$dateiaus .= ".jpg";

imagejpeg ( $chart , $dateiaus);
imagedestroy($chart);

# Das erzeugte Bild wird nun im Browser gezeigt.
print("<br><img src='./$dateiaus'>");
?>